/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.JenisProfile;
import com.portofolio.entity.vo.JenisProfileId;

@Lazy
@Repository
public interface JenisProfileDao extends CrudRepository<JenisProfile, Integer> {

    

    @Query(QListAll)
    Page<Map<String, Object>> findAllList( @Param("statusEnabled") boolean statusEnabled,Pageable page);
    
    @Query(QListAll + " and model.namaJenisProfile like %:namaJenisProfile% ")
    Page<Map<String, Object>> findAllList(@Param("namaJenisProfile") String namaJenisProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    @Query(QListAll + " and model.kdJenisProfile = :kdJenisProfile")
    Map<String, Object> findByKdJenisProfile(@Param("kdJenisProfile") Integer kdJenisProfile,@Param("statusEnabled") boolean statusEnabled);
    
    
    String QListAll ="select new map(model.kdJenisProfile as kdJenisProfile "
            + ", model.namaJenisProfile as namaJenisProfile " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kdJenisProfileHead as kdJenisProfileHead "
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", model.version as version )" 
            + " from JenisProfile model "
            + "left join model.jenisProfileHead jenisProfileHead where model.statusEnabled=:statusEnabled ";

}
